<script lang="ts">
import Vue from 'vue';
import TabProjectionBlock from './tab-projection-block.vue';

export default Vue.extend({
  name: 'ComparisonPane',
  components: {
    TabProjectionBlock,
  },
  props: {
    projectionBaseData: {
      type: Object,
      required: false,
      default: null,
    },
    stage: {
      type: String,
      required: false,
      default: '',
    },
    comparisonData: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      baseHarveyUrl: '/nuxt-images/competition/progress-bars/',
      progressBarAltTextBase:
        'Progress bar that shows the current feature capability as ',
    };
  },
  methods: {
    progressBarLegend(value: number) {
      switch (value) {
        case 0:
          return 'little or no capability';
        case 25:
          return 'basic';
        case 50:
          return 'adequate';
        case 75:
          return 'good';
        case 100:
          return 'comprehensive';
        default:
          return null;
      }
    },
  },
});
</script>

<template>
  <div class="analysis-pane">
    <div class="analysis-pane-title">
      <SlpTypography variant="heading5-bold">{{
        comparisonData.company
      }}</SlpTypography>
      <nuxt-img
        v-if="comparisonData.coverage !== undefined"
        class="slp-mt-8 comparison__img"
        loading="lazy"
        :alt="`${progressBarAltTextBase}${progressBarLegend(
          comparisonData.coverage,
        )}`"
        :src="`${baseHarveyUrl}${comparisonData.coverage}.svg`"
        format="webp"
        quality="99"
      />
    </div>
    <SlpTypography
      v-if="comparisonData.description"
      class="slp-mt-32"
      variant="body1-bold"
      tag="p"
      >{{ comparisonData.description }}
    </SlpTypography>
    <TabProjectionBlock
      v-if="comparisonData.projected_coverage"
      :projection-base-data="projectionBaseData"
      :data="comparisonData.projected_coverage"
      :stage="stage"
    />
    <SlpTypography
      v-if="
        comparisonData.coverage === 0 &&
        comparisonData.description === undefined
      "
      class="slp-mt-32"
      variant="body1-bold"
      tag="p"
    >
      Not offered by {{ comparisonData.company }}.
    </SlpTypography>
    <div v-if="comparisonData.details">
      <SlpTypography variant="body1-bold" tag="p" class="slp-mt-48">
        Details
      </SlpTypography>
      <div class="content" v-html="$md.render(comparisonData.details)" />
    </div>
    <div v-if="comparisonData.improving_product_capabilities" class="slp-mt-48">
      <SlpTypography variant="heading5-bold" tag="p">
        Improving our product capabilities
      </SlpTypography>
      <div
        class="content"
        v-html="$md.render(comparisonData.improving_product_capabilities)"
      />
    </div>
    <div v-if="comparisonData.additional" class="slp-mt-48">
      <SlpTypography variant="heading5-bold" tag="p">
        Additional
      </SlpTypography>
      <div class="content" v-html="$md.render(comparisonData.additional)" />
    </div>
    <SlpButton
      v-if="comparisonData.link_to_documentation"
      class="zero-padding slp-mt-64"
      variant="tertiary"
      :href="comparisonData.link_to_documentation"
      data-ga-name="link to documentation"
      data-ga-location="body"
    >
      Documentation
      <SlpIcon
        name="chevron-lg-right"
        variant="product"
        alt="Chevron Right Icon"
      />
    </SlpButton>
  </div>
</template>

<style scoped lang="scss">
.content {
  margin-left: $spacing-16;
  &:deep ul {
    list-style: disc;

    li {
      margin-left: $spacing-24;
    }
  }

  &:deep li {
    margin-top: $spacing-8;
  }
}

.zero-padding {
  padding-left: 0;
}

ul {
  margin-left: $spacing-24;
  list-style: disc;

  li {
    margin-top: $spacing-16;

    &:first-child {
      margin-top: $spacing-24;
    }
  }
}

.analysis-pane {
  padding: $spacing-32 $spacing-24 $spacing-48 $spacing-24;

  .comparison__img {
    min-width: 120px;
  }
}

.analysis-pane-title {
  display: flex;
  flex-direction: column;
  align-items: center;

  .slp-icon {
    width: 32px;
    height: 32px;
  }

  @media (max-width: $breakpoint-md) {
    display: none;
  }
}
</style>
